=== debian/changelog ===
condor (8.2.3~dfsg.1-6~nd14.04+1+nd14.10+1) utopic; urgency=low

  * Backported for utopic.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Wed, 28 Jan 2015 11:44:04 -0500

condor (8.2.3~dfsg.1-6~nd14.04+1) trusty; urgency=low

  * Backported for trusty.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Team
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Team <team@neuro.debian.net>  Thu, 15 Jan 2015 16:19:58 +0100

condor (8.2.3~dfsg.1-6) unstable; urgency=medium

  * Apply upstream patch to fix CVE-2014-8126

 -- Alex Waite <Alexqw85@gmail.com>  Thu, 15 Jan 2015 10:55:13 +0100

condor (8.2.3~dfsg.1-5) unstable; urgency=medium

  * Fix wrong default SPOOL location introduced with 8.2.3~dfsg.1-4. Whenever
    not overwritten by an explicit SPOOL setting, this version relocated
    SPOOL to /var/lib/condor/lib. Consequently, existing job and usage logs
    where inaccessible by HTcondor. This update reverts this unintentional
    change and sets SPOOL explicitly to /var/spool/condor again.
    (Closes: #772170)

 -- Michael Hanke <mih@debian.org>  Fri, 05 Dec 2014 20:32:17 +0100

condor (8.2.3~dfsg.1-4) unstable; urgency=medium

  * Adjust mechanism to apply the default Debian configuration to cope with
    the removal of the monolithic configuration file in the 8.2.x series.
    The default configuration is now applied as a patch to the table of
    parameters in the HTCondor sources (Closes: #769100).
    The report of leaving behind an unowned directory is merely a symptom of
    this bug.
  * Adjust default configuration to make HTCondor work with Debian's
    ganglia (also see Ticket #4709). Thanks to Alex Waite for the fix.
  * Add Debconf template translation:
    - Dutch -- courtesy of Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      (Closes: #766067)

 -- Michael Hanke <mih@debian.org>  Sat, 29 Nov 2014 09:57:27 +0100

condor (8.2.3~dfsg.1-3) unstable; urgency=medium

  * Modify the DMTCP shim script to work with the 2.x series of DMTCP.

 -- Michael Hanke <mih@debian.org>  Fri, 17 Oct 2014 20:43:10 +0200

condor (8.2.3~dfsg.1-2) unstable; urgency=medium

  * Add transitional dummy packages to enable seamless upgrades from the
    "condor*" packages in wheezy. Apparently, the provides/replaces/conflicts
    triplet doesn't work with apt or aptitude in jessie.

 -- Michael Hanke <mih@debian.org>  Tue, 07 Oct 2014 13:33:55 +0200

condor (8.2.3~dfsg.1-1) unstable; urgency=medium

  * Add patch to prevent FTBFS when built with --as-needed (Closes: #758923).
    Thanks to Artur Rona.
  * Add 'provides: condor*' statements to debian/control to ensure a smooth
    upgrade path.
  * Move upstream meta data: debian/upstream -> debian/upstream/metadata
  * Added patch to increase the robustness of the sentinel job submitted by
    condor_qsub (Closes: #692388). Thanks to Philip Chase for the patch.

 -- Michael Hanke <mih@debian.org>  Sat, 04 Oct 2014 14:59:29 +0200
